unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, BufDataset, DB, Forms, Controls, Graphics, Dialogs,
  DBGrids, xmlDataPacketReader;

type

  { TForm1 }

  TForm1 = class(TForm)
    BufDataset1: TBufDataset;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

const
  FILE_NAME = 'data.xml';

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
var
  i: Integer;
  F: TField;
begin
  if not FileExists(FILE_NAME) then
  begin
    BufDataset1.FieldDefs.Add('DATE', ftDate);
    BufDataset1.FieldDefs.Add('NUMBER', ftFloat);
    BufDataset1.CreateDataset;
    BufDataset1.Open;
    for i := 0 to 100 do
      BufDataset1.AppendRecord([
        Random(365) + EncodeDate(2020, 1, 1),
        Random *1000
      ]);
  end else
    BufDataset1.LoadFromFile(FILE_NAME, dfXML);

  F := BufDataset1.FieldByName('DATE');
  if F is TDateField then
    TDateField(F).DisplayFormat := 'yyyy-mm-dd';
  F := BufDataset1.FieldByName('NUMBER');
  if F is TFloatField then
    TFloatField(F).DisplayFormat := '0.00';
end;

procedure TForm1.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  BufDataset1.SaveToFile(FILE_NAME, dfXML);
  BufDataset1.Close;
end;

end.

